#include "dbxreader.h"
#include "dbx.h"
#include "dbxexception.h"
#include <iostream>

#include <windows.h>

void dbxreader::processfromregistry()
{
  // To do: find path from the HKCU\Identities\{id}\Software\Microsoft\Outlook Express\5.0\StoreRoot key
  processdirectory("\\");
}

void dbxreader::processdirectory(std::string path)
{
  if (path[path.size()-1]!='\\')
    path+='\\';
  std::string glob=path+"*.dbx";

  WIN32_FIND_DATA FileData;
  HANDLE hSearch = FindFirstFile(glob.c_str(),&FileData);
  if (hSearch == INVALID_HANDLE_VALUE)
    throw dbxexception("No Outlook Express folder database (*.dbx) files found.");

  bool finished=false;
  do {
    std::cout << "Processing file " << FileData.cFileName << std::endl;
    dbx b(path+std::string(FileData.cFileName),this);
    if (!FindNextFile(hSearch, &FileData))
      if (GetLastError() == ERROR_NO_MORE_FILES)
        finished=true;
      else
        throw dbxexception("Couldn't find next file.");
  } while(!finished);
}
