#ifndef DBXREADER_H
#define DBXREADER_H

#include "dbx.h"
#include "processor.h"
#include <vector>

class dbxreader : public processor
{
public:
  void add(processor& proc) { processors_.push_back(&proc); }
  void processfromregistry();
  void processdirectory(std::string path);

  void process(message& m)
  {
    for (std::vector<processor*>::const_iterator i=processors_.begin();i!=processors_.end();++i)
      (*i)->process(m);
  }

private:
  std::vector<processor*> processors_;
};

#endif // DBXREADER_H
