#include <iostream>
#include <exception>
#include "dbxreader.h"
#include "timestats.h"
#include "messagesaver.h"
#include "unkanal.h"

int main()
{
  try {
    dbxreader r;
    timestats s;
    unkanal u;
    messagesaver m("output");
    r.add(s);
    r.add(m);
    r.add(u);
    r.processdirectory("data");
    s.output("times.txt");
    u.output("unknowns.txt");
  }
  catch (std::exception& e)
  {
    std::cout << "DBXTool exception: " << e.what() << std::endl;
    return 1;
  }
  catch (...)
  {
    std::cout << "DBXTool: Unknown exception!" << std::endl;
    return 1;
  }
  return 0;
}
