#include "def.h"
#include "message.h"
#include "dbxexception.h"
#include <string>
#include <vector>
#include <map>

void message::set_body(std::string body)
{
  body_=body;
  if (body!="") {
    std::vector<std::string> lines;
    std::string::size_type p,sp=0;
    do {
      p=body.find("\r\n",sp);
      std::string line=body.substr(sp,(p==std::string::npos ? p : p-sp));
      lines.push_back(line);
      sp=p+2;
    } while (p!=std::string::npos);

    std::string header=lines[0]+" ";
    int i=1;
    do {
      if (i==lines.size() || lines[i]=="" || !whitespace(lines[i][0])) {
        std::string::size_type p=header.find(":");
        if (p==std::string::npos || p==0)
          throw dbxexception("Malformed message");
        set_string(strip(header.substr(0,p)),strip(header.substr(p+1)));;
        header="";
        if (i==lines.size() || lines[i]=="")
          break;
      }
      header+=strip(lines[i])+" ";
      ++i;
    } while(true);

    if (got_string("XRef")!=got_string("X-DBXTool-XRef"))
      throw dbxexception("Only one XRef!");
    if (got_string("XRef") && get_string("XRef")!=get_string("X-DBXTool-XRef"))
      throw dbxexception("XRef in message body does not match dbx item!");
  }
}
