#ifndef MESSAGE_H
#define MESSAGE_H

#include "def.h"
#include <map>
#include <string>

class message
{
public:
  message() : bools_(cisc_), ints_(cisc_), int6s_(cisc_), strings_(cisc_) { }

  bool get_bool(std::string name) { return bools_[name]; }
  void set_bool(std::string name,bool value) { bools_[name]=value; }
  bool got_bool(std::string name) const { boollist::const_iterator i=bools_.find(name); return i!=bools_.end(); }

  int get_int(std::string name) { return ints_[name]; }
  void set_int(std::string name,int value) { ints_[name]=value; }
  bool got_int(std::string name) const { intlist::const_iterator i=ints_.find(name); return i!=ints_.end(); }

  int6 get_int6(std::string name) { return int6s_[name]; }
  void set_int6(std::string name,int6 value) { int6s_[name]=value; }
  bool got_int6(std::string name) const { int6list::const_iterator i=int6s_.find(name); return i!=int6s_.end(); }

  std::string get_string(std::string name) { return strings_[name]; }
  void set_string(std::string name,std::string value) { strings_[name]=value; }
  bool got_string(std::string name) const { stringlist::const_iterator i=strings_.find(name); return i!=strings_.end(); }

  void set_body(std::string body);
  std::string get_body() { return body_; }

private:
  class cic_functor
  {
  public:
    bool operator() (const std::string& x,const std::string& y) const
    {
      return lexicographical_compare(x.begin(),x.end(),y.begin(),y.end(),cicomp);
    }
  private:
    static bool cicomp(char x,char y) { return toupper(x)<toupper(y); }
  };
  cic_functor cisc_;

  typedef std::map<std::string,bool,cic_functor> boollist;
  typedef std::map<std::string,int,cic_functor> intlist;
  typedef std::map<std::string,int6,cic_functor> int6list;
  typedef std::map<std::string,std::string,cic_functor> stringlist;

  boollist bools_;
  intlist ints_;
  int6list int6s_;
  stringlist strings_;

  std::string body_;

  static bool whitespace(char c) { return c==' ' || c=='\t'; }
  static std::string strip(std::string s)
  {
    std::string::size_type sp=s.find_first_not_of(" \t");
    if (sp==std::string::npos)
      return "";
    return s.substr(sp,1+s.find_last_not_of(" \t")-sp);
  }
};

#endif // MESSAGE_H
