#ifndef TIMESTATS_H
#define TIMESTATS_H

#include "def.h"
#include "processor.h"
#include <string>
#include <vector>
#include <limits>

class timestats : public processor
{
public:
  timestats() : mint_(std::numeric_limits<int6>::max()), maxt_(std::numeric_limits<int6>::min()) { }
  void process(message& m)
  {
    int6 t=m.get_int6("X-DBXTool-Received");
    times_.push_back(t);
    if (t<mint_)
      mint_=t;
    if (t>maxt_)
      maxt_=t;
  }

  void output(std::string ofname);

private:
  std::vector<int6> times_;

  static std::string datefromtime64(int6 t);
  int6 mint_,maxt_;
};

#endif // TIMESTATS_H
