#ifndef UNKANAL_H
#define UNKANAL_H

#include "def.h"
#include "processor.h"
#include <string>
#include <vector>
#include <limits>
#include <fstream>
#include <algorithm>

class unkanal : public processor
{
public:
  unkanal()
  {
    for (int i=0;i<16;++i)
      fs[i]=0;
  }
  void process(message& m)
  {
    bool f11=m.get_bool("X-DBXTool-Flag11");
    bool f18=m.get_bool("X-DBXTool-Flag18");
    bool g0f=m.got_int("X-DBXTool-Item-0f");
    bool news=m.get_bool("X-DBXTool-News");
    int i0f=0;
    if (g0f)
      i0f=m.get_int("X-DBXTool-Item-0f");
    int f=(news ? 8 : 0)+(g0f ? 4 : 0)+(f18 ? 2 : 0)+(f11 ? 1 : 0);
    ++fs[f];

    i0fs.push_back(i0f);
  }

  void output(std::string ofname)
  {
    std::ofstream out;
    out.exceptions(std::ios_base::badbit | std::ios_base::failbit | std::ios_base::eofbit);
    out.open(ofname.c_str(),std::ios_base::out | std::ios_base::trunc);

    for (int j=0;j<16;++j)
      out << j << ": " << fs[j] << std::endl;
    out << std::endl;

    sort(i0fs.begin(),i0fs.end());
    std::vector<int>::const_iterator i=i0fs.begin();
    int i0f=*i;
    int c=1;
    for (++i;i!=i0fs.end();++i,++c)
      if (i0f!=*i || i==i0fs.end()-1) {
        out << i0f << ": " << c << std::endl;
        i0f=*i;
        c=1;
      }
  }

private:
  int fs[16];
  std::vector<int> i0fs;
};

#endif // UNKANAL_H
